-- Main Frame
smb_frame = CreateFrame("Frame", nil, UIParent, BackdropTemplateMixin and "BackdropTemplate");
smb_frame:SetScript("OnEvent", smb_on_chat);
smb_frame:RegisterEvent("CHAT_MSG_CHANNEL");
smb_frame:SetScript("OnUpdate", function(self, sinceLastUpdate) smb_frame:onUpdate(sinceLastUpdate); end);

function smb_frame:onUpdate(sinceLastUpdate)
	self.sinceLastUpdate = (self.sinceLastUpdate or 0) + sinceLastUpdate;
	if ( self.sinceLastUpdate >= 1 ) then
		update(0);
		self.sinceLastUpdate = 0
	end
end

function smb_close(this)
	this:GetParent():Hide()
	smb_out("|cff00ccffSpam Message Board closed.  Type '/smb show' to open it again.");
end

smb_frame:ClearAllPoints()
smb_frame:SetPoint("TOPLEFT",UIParent)
smb_frame:SetHeight(smb_h)
smb_frame:SetWidth(smb_w)

smb_frame:SetBackdrop({
	bgFile = "Interface\\Tooltips\\UI-Tooltip-Background", tile = true, tileSize = 16,
	edgeFile = "Interface\\AddOns\\SpamMessageBoard\\textures\\otravi-semi-full-border", edgeSize = 32,
	insets = {left = 1, right = 1, top = 32, bottom = 1},
})
smb_frame:SetBackdropBorderColor(0.0,0.0,1.0)
smb_frame:SetBackdropColor(24/255, 24/255, 24/255)

smb_frame:SetScale(1)
smb_frame:EnableMouse(true)
smb_frame:SetMovable(true)
smb_frame:RegisterForDrag("LeftButton")
smb_frame:SetScript("OnDragStart",smb_frame.StartMoving)
smb_frame:SetScript("OnDragStop",smb_frame.StopMovingOrSizing)

smb_frame:SetScript("OnMouseDown", function(this) 
					if ( ( ( not this.isLocked ) or ( this.isLocked == 0 ) ) and ( arg1 == "LeftButton" ) ) then
					  this:StartMoving();
					  this.isMoving = true;
					 end
					end)
smb_frame:SetScript("OnMouseUp", function(this) 
					if ( this.isMoving ) then
					  this:StopMovingOrSizing();
					  this.isMoving = false;
					  if this.SavePosition then
						this:SavePosition()
					  end
					 end
					end)






-- Title
smb_frame.Title=smb_frame:CreateFontString(nil,"ARTWORK","GameFontNormal")
smb_frame.Title:SetPoint("TOPLEFT",smb_frame,"TOPLEFT",6,-15)
smb_frame.Title:SetTextColor(1.0,1.0,1.0,1.0)
smb_frame.Title:SetText("Spam Message Board:")

-- Message slots...
smb_frame.text = {}
smb_frame.time = {}
smb_frame.subframe = {}

for i = 0, smb_s, 1 do
	smb_frame.text[i] = smb_frame:CreateFontString(nil,"ARTWORK","ChatFontNormal")
	smb_frame.text[i]:SetPoint("TOPLEFT",smb_frame,"TOPLEFT",6,-30 - i * 18)
	smb_frame.text[i]:SetJustifyH("left");
	smb_frame.text[i]:SetWordWrap(false)
	smb_frame.text[i]:SetWidth(smb_w - 70);
	smb_frame.text[i]:SetHeight(18);

	smb_frame.time[i] = smb_frame:CreateFontString(nil,"ARTWORK","ChatFontNormal")
	smb_frame.time[i]:SetPoint("TOPLEFT",smb_frame,"TOPRIGHT",-75,-30 - i * 18)
	smb_frame.time[i]:SetJustifyH("right");
	smb_frame.time[i]:SetWordWrap(false)
	smb_frame.time[i]:SetWidth(70);
	smb_frame.time[i]:SetHeight(18);
	
	smb_frame.subframe[i] = CreateFrame("Button", "ARTWORK", smb_frame, BackdropTemplateMixin and "BackdropTemplate")
	smb_frame.subframe[i]:SetWidth(smb_w);
	smb_frame.subframe[i]:SetHeight(18);
	smb_frame.subframe[i]:SetPoint("TOPLEFT",smb_frame,"TOPLEFT",6,-30 - i * 18)
	smb_frame.subframe[i]:EnableMouse(false);
	smb_frame.subframe[i].id = i;
	smb_frame.subframe[i]:SetScript("OnMouseUp", smb_StartWhisper)
	smb_frame.subframe[i]:SetScript("OnEnter", smb_ShowTooltip)
	smb_frame.subframe[i]:SetScript("OnLeave", function() smb_tooltip:Hide() end)
end

-- Exclude Edit Box

smb_frame.ExcludeText=CreateFrame("EditBox", nil, smb_frame, BackdropTemplateMixin and "BackdropTemplate");
smb_frame.ExcludeText:SetWidth(80)
smb_frame.ExcludeText:SetHeight(18)
smb_frame.ExcludeText:SetAutoFocus(false);
smb_frame.ExcludeText:SetMultiLine(false);
smb_frame.ExcludeText:SetFontObject(ChatFontNormal)
smb_frame.ExcludeText:SetPoint("TOPRIGHT",smb_frame,"TOPRIGHT",-40,-12)
smb_frame.ExcludeText:SetScript("OnEscapePressed", function(this) this:ClearFocus() end)

smb_frame.ExcludeText_Text = smb_frame:CreateFontString(nil,"ARTWORK","GameFontNormal")
smb_frame.ExcludeText_Text:SetPoint("TOPRIGHT",smb_frame,"TOPRIGHT",-128,-15)
smb_frame.ExcludeText_Text:SetTextColor(1.0,1.0,1.0,1.0)
smb_frame.ExcludeText_Text:SetText("Exclude:")

smb_frame.ExcludeText_BackDrop = CreateFrame("Frame", nil, smb_frame, BackdropTemplateMixin and "BackdropTemplate");
smb_frame.ExcludeText_BackDrop:SetWidth(80)
smb_frame.ExcludeText_BackDrop:SetHeight(18)
smb_frame.ExcludeText_BackDrop:SetPoint("TOPRIGHT",smb_frame,"TOPRIGHT",-44,-12)
smb_frame.ExcludeText_BackDrop:SetBackdrop({bgFile = "Interface/Tooltips/UI-Tooltip-Background" });
smb_frame.ExcludeText_BackDrop:SetBackdropColor(0,0,0,1);

-- Filter Edit Box

smb_frame.FilterText=CreateFrame("EditBox", nil, smb_frame, BackdropTemplateMixin and "BackdropTemplate");
smb_frame.FilterText:SetWidth(80)
smb_frame.FilterText:SetHeight(18)
smb_frame.FilterText:SetAutoFocus(false);
smb_frame.FilterText:SetMultiLine(false);
smb_frame.FilterText:SetFontObject(ChatFontNormal)
smb_frame.FilterText:SetPoint("TOPRIGHT",smb_frame,"TOPRIGHT",-182,-12)
smb_frame.FilterText:SetScript("OnEscapePressed", function(this) this:ClearFocus() end)

smb_frame.FilterText_Text = smb_frame:CreateFontString(nil,"ARTWORK","GameFontNormal")
smb_frame.FilterText_Text:SetPoint("TOPRIGHT",smb_frame,"TOPRIGHT",-274,-15)
smb_frame.FilterText_Text:SetTextColor(1.0,1.0,1.0,1.0)
smb_frame.FilterText_Text:SetText("Filter For:")

smb_frame.FilterText_BackDrop = CreateFrame("Frame", nil, smb_frame, BackdropTemplateMixin and "BackdropTemplate");
smb_frame.FilterText_BackDrop:SetWidth(80)
smb_frame.FilterText_BackDrop:SetHeight(18)
smb_frame.FilterText_BackDrop:SetPoint("TOPRIGHT",smb_frame,"TOPRIGHT",-184,-12)
smb_frame.FilterText_BackDrop:SetBackdrop({bgFile = "Interface/Tooltips/UI-Tooltip-Background" });
smb_frame.FilterText_BackDrop:SetBackdropColor(0,0,0,1);

-- Spam Helper Button
smb_frame.SpamHelper=CreateFrame("Button",nil,smb_frame, BackdropTemplateMixin and "BackdropTemplate")
smb_frame.SpamHelper:SetNormalTexture("Interface\\Buttons\\UI-Panel-BiggerButton-Up.PNG")
smb_frame.SpamHelper:SetPushedTexture("Interface\\Buttons\\UI-Panel-BiggerButton-Down.PNG")
smb_frame.SpamHelper:SetHighlightTexture("Interface\\Buttons\\UI-Panel-BiggerButton-Disabled.PNG")
smb_frame.SpamHelper:SetWidth(20)
smb_frame.SpamHelper:SetHeight(20)
smb_frame.SpamHelper:SetPoint("TOPRIGHT",smb_frame,"TOPRIGHT",-24,-12)
smb_frame.SpamHelper:SetScript("OnClick", smb_openHelper)

-- Close Button
smb_frame.CloseButton=CreateFrame("Button",nil,smb_frame, BackdropTemplateMixin and "BackdropTemplate")
smb_frame.CloseButton:SetNormalTexture("Interface\\Buttons\\UI-Panel-MinimizeButton-Up.blp")
smb_frame.CloseButton:SetPushedTexture("Interface\\Buttons\\UI-Panel-MinimizeButton-Down.blp")
smb_frame.CloseButton:SetHighlightTexture("Interface\\Buttons\\UI-Panel-MinimizeButton-Highlight.blp")
smb_frame.CloseButton:SetWidth(20)
smb_frame.CloseButton:SetHeight(20)
smb_frame.CloseButton:SetPoint("TOPRIGHT",smb_frame,"TOPRIGHT",-4,-12)
smb_frame.CloseButton:SetScript("OnClick", smb_close)
